package cn.fw.hermes.common.utils.im;

 import cn.fw.hermes.common.utils.DateUtils;
 import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.Date;
import java.util.Scanner;
import java.util.zip.GZIPInputStream;

/**
 * 消息拉取解析
 *
 * @author Kurisu
 * @date 2018-09-08
 */
public class FileUtils {
    /**
     * 获取文件的流
     *
     * @param uri
     * @return
     */
    public static InputStream downloadNet(String uri) {
        // 下载网络文件
        try {
            URL url = new URL(uri);
            URLConnection conn = url.openConnection();
            return conn.getInputStream();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 解压并解析文件
     */
    public static void unGzipFile(InputStream inStream) throws IOException {
        //使用GZIPInputStream解压GZ文件
        InputStream in = new GZIPInputStream(inStream);
        Scanner sc = new Scanner(in);
        StringBuffer sb = new StringBuffer();
        while (sc.hasNextLine()) {
            String line = sc.nextLine();
            sb.append(line);
        }
        System.out.println(sb.toString());
        JSONObject jsonObject = JSON.parseObject(sb.toString());
        System.out.println("SdkAppId: " + jsonObject.get("SdkAppId"));
        JSONArray msgList = jsonObject.getJSONArray("MsgList");
        for (Object aMsgList : msgList) {
            System.out.println("-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-");
            JSONObject object = (JSONObject) aMsgList;
            System.out.println("发送方：" + object.get("From_Account"));
            System.out.println("接收方：" + object.get("To_Account"));
            System.out.println("发送时间：" + DateUtils.formatFull(new Date(Long.valueOf(object.get("MsgTimestamp").toString() + "000"))));
            System.out.println("MsgSeq：" + object.get("MsgSeq"));
            JSONArray msgBody = object.getJSONArray("MsgBody");
            for (Object aMsgBody : msgBody) {
                JSONObject object1 = (JSONObject) aMsgBody;
                System.out.println("消息类型：" + object1.get("MsgType"));
                JSONObject content = (JSONObject) object1.get("MsgContent");
                System.out.println("内容：" + content.get("Text"));
            }
        }
    }
}
